;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Video setup
;
; PRINT USR SETUP;[Frame]
;
;================================

ORG 4084

@Class6=0D92			;Expression evaluator, if value>255 then error B
@StackA=0C02			;Move results to A
@Bank1=2000			;Bank 1 chr set
@BMPData=2800			;BMP Data
@RAMTop=4004			;Ramtop address=Start of .bin data
@Stor=4041			;Flip line store
;================================
;Convert
	CALL Flip		;Flip BMP image
	CALL Convert		;Convert BMP to chr patterns
	CAll Invert		;Invert bottom half of BMP image
@Store
	RST 20			;Get next character
	CALL Class6		;Evaluate [Frame] expression 
	CALL StackA		;A=Frame
	LD HL,(Ramtop)
	DEC A			;Zero test
	AND A
	JR Z Start
	LD B,A			;Frame number
	LD DE,0400		;Frame size
@NextFrame
	ADD HL,DE		;Calculate destination
	DJNZ NextFrame
@Start
	EX DE,HL		;Set destination
	LD HL,Bank1		;Set source
	LD BC,0400		;Byte count
	LDIR
	RST 08
	FF
;================================
; Flip BMP image
;================================
@Flip
	LD HL,BMPData		;Start of BMPData
	LD (Stor),HL		;Save top row addr
	LD BC,03F0		;Offset to bottom row
	ADD HL,BC		;HL=Address of bottom row.
	LD B,20			;Rows to process counter, 32
	LD A,10			;Constant, 16 Bytes/row
@FlipLup
	PUSH BC			;PUSH counter
	LD (Stor+2),HL		;Save bottom row addr
	LD HL,(Stor)		;Transfer top row data to storage area
	LD DE,Stor+4
	LD BC,0010
	LDIR
	LD HL,(Stor)		;Transfer bottom row data to top row address
	EX DE,HL
	LD HL,(Stor+2)
	LD C,A
	LDIR
	LD (Stor),DE		;Save top row address
	LD HL,Stor+4		;Transfer top row data to bottom row address
	LD DE,(Stor+2)
	LD C,A
	LDIR
	LD C,A			;Calculate address of next bottom row
	LD HL,(Stor+2)
	AND A			;Clear CY
	SBC HL,BC
	POP BC			;POP row counter
	DJNZ FlipLup		;Repeat if NZ
	RET
;================================
; Convert frames to chr bit patterns
;================================
@Convert
	LD HL,BMPData		;Start of 1st frame
@NxtFrame
	LD DE,Bank1		;DE=Bank 1 addr
@Loop
	LD B,10			;16x8 characters
@Outer
	PUSH BC			;PUSH counter
	PUSH HL			;PUSH BMP addr
	LD BC,0008		;Counter, 8 bytes/character
@Inner
	LDI
	LD A,24			;End of bank test
	CP D			;End of bank 1?
	JR Z End
	LD A,C			;Save counter to A
	LD C,0F			;Next BMP row
	ADD HL,BC
	LD C,A			;Restore counter
	AND A			;Zero test
	JR NZ Inner		;Loop until C=0
	POP HL			;POP BMP addr
	INC HL			;Next BMP addr
	POP BC			;POP counter
	DJNZ Outer		;Loop until B=0
	LD C,70			;70,Next row offset, 112 bytes
	ADD HL,BC		;Start of next row
	JR Loop
@End
	POP HL			;Clear stack
	POP BC			;
	RET
;================================
; Invert bottom half of each frame
;================================
@Invert
	LD HL,Bank1		;Start of bank 1
	LD BC,01FF		;Byte count
@InvLup
	LD A,(HL)		;Get byte
	CPL			;Compliment
	LD (HL),A		;Store byte
	INC HL			;Next BMP addr
	LD A,B			;Decrease counter
	OR C
	DEC BC
	JR NZ InvLup
	RET
